/*******************************************************************************
Copyright © 2024 Sebastian Roith

Licensed under CC BY 4.0. To view a copy of this license, visit http://creativecommons.org/licenses/by/4.0/
*******************************************************************************/

(function(window) {

const TABLES = [
    { "name": "VERDAECHTIGE", "primary": ["id"], "table": [
        ["id","name","geschlecht","alter","groesse","haare","brille"],
        [11,"Anton","m",19,184,"braun",0],
        [23,"Berta","w",14,172,"grau",0],
        [18,"Cem","m",32,180,"schwarz",1],
        [5,"Dora","w",50,184,"rot",1],
        [32,"Enrique","m",28,157,"rot",0],
        [14,"Fridolin","m",33,167,"grau",1],
        [22,"George","m",16,171,"blond",0],
        [31,"Heike","w",25,184,"schwarz",1],
        [16,"Ida","w",35,167,"braun",0],
        [8,"Jamie","d",21,170,"blond",1],
        [12,"Kaia","w",28,182,"schwarz",0],
        [10,"Ludwig","m",37,184,"weiß",1],
        [33,"Marvin","m",19,173,"schwarz",1],
        [21,"Noella","w",18,192,"braun",0],
        [17,"Olga","w",27,160,"grau",0],
        [20,"Paula","w",25,181,"schwarz",1],
        [7,"Quila","w",22,192,"blond",1],
        [30,"Regina","w",26,179,"lila",0],
        [1,"Sascha","d",33,191,"braun",1],
        [6,"Tobi","m",14,174,"blond",0],
        [4,"Uli","w",15,181,"rot",0],
        [19,"Vy","w",43,195,"braun",0],
        [2,"Wilhelm","m",38,196,"braun",0],
        [9,"Xenia","w",14,182,"schwarz",0],
        [15,"York","m",36,172,"weiß",1],
        [3,"Zayn","m",35,193,"blond",0]
    ] }
];

const LEVELS = [
    {
        "task": "<p>In der Tabelle <code>VERDAECHTIGE</code> speichert Informationen über Verdächtige in einem Kriminalfall.</p><p>Mache dich zunächst mit der Datenbanktabelle vertraut. Schreibe dazu zuerst eine Abfrage, die dir eine der Datenbanktabelle möglichst ähnliche Ergebnistabelle liefert. Führe sie aus und schaue dir die Ergebnistabelle genau an.</p>",
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "between", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „BETWEEN“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 7, "fine": 1, "msg": "Alle Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "id", "fine": 1, "msg": "Das erste Attribut muss „id“ sein" },
            { "type": "attributeName", "index": 1, "value": "name", "fine": 1, "msg": "Das zweite Attribut muss „name“ sein" },
            { "type": "attributeName", "index": 2, "value": "geschlecht", "fine": 1, "msg": "Das dritte Attribut muss „geschlecht“ sein" },
            { "type": "attributeName", "index": 3, "value": "alter", "fine": 1, "msg": "Das vierte Attribut muss „alter“ sein" },
            { "type": "attributeName", "index": 4, "value": "groesse", "fine": 1, "msg": "Das zweite Attribut muss „groesse“ sein" },
            { "type": "attributeName", "index": 5, "value": "haare", "fine": 1, "msg": "Das dritte Attribut muss „haare“ sein" },
            { "type": "attributeName", "index": 6, "value": "brille", "fine": 1, "msg": "Das vierte Attribut muss „brille“ sein" },
            { "type": "sameResult", "value": "SELECT * FROM VERDAECHTIGE", "fine": 1, "msg": "Die Ergebnistabelle dieser Abfrage entspricht nicht bestmöglich der Datenbanktabelle…" },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "<p>Benötigt werden <code>name</code>, <code>geschlecht</code>, <code>groesse</code> und <code>haare</code> von allen Verdächtigen, die männlich sind und zugleich mindestens 190 cm groß sind.</p>",
        "code": "SELECT * FROM VERDAECHTIGE",
        "keepCode": true,
        "readonly": false,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "or", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „OR“ nicht erlaubt…" },
            { "type": "keyword", "value": "not", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „NOT“ nicht erlaubt…" },
            { "type": "keyword", "value": "in", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „IN“ nicht erlaubt…" },
            { "type": "keyword", "value": "between", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „BETWEEN“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 4, "fine": 1, "msg": "Nur die genannten Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "name", "fine": 1, "msg": "Das erste Attribut muss „name“ sein" },
            { "type": "attributeName", "index": 1, "value": "geschlecht", "fine": 1, "msg": "Das zweite Attribut muss „geschlecht“ sein" },
            { "type": "attributeName", "index": 2, "value": "groesse", "fine": 1, "msg": "Das dritte Attribut muss „groesse“ sein" },
            { "type": "attributeName", "index": 3, "value": "haare", "fine": 1, "msg": "Das vierte Attribut muss „haare“ sein" },
            { "type": "sameResult", "value": "SELECT name, geschlecht, groesse, haare FROM VERDAECHTIGE WHERE geschlecht = 'm' AND groesse >= 190", "fine": 1 },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "<p>Probiere diese Abfrage aus und beantworte dann die Frage:</p>",
        "code": "SELECT name, geschlecht, groesse, haare \n  FROM VERDAECHTIGE \n  WHERE geschlecht = 'm' \n    OR groesse >= 190",
        "readonly": true,
        "tables": TABLES,
        "locked": true,
        "checkCode": [],
        "checkTermination": [
            { "type": "accept", "unlock": true }
        ],
        "questionWrongFine": 1,
        "question": {
            "html": "Welche der nachfolgenden Aussagen ist für diese Abfrage korrekt? Kreuze an und ergänze die Lückeninhalte:",
            "choices": [
                { "html": "Die Abfrage enthält ", "type": "number", "min": 0, "step": 1, "unit": " Gleichung(en) bzw. Ungleichung(en).", "accept": "2", "correct": true },
                { "html": "(Un-)Gleichungen sind mit dem Schlüsselwort ", "type": "text", "casesensitive": false, "unit": " verknüpft.", "accept": "OR", "correct": true },
                { "html": "Statt <code>=</code>, <code>&lt;</code>, <code>&lt;=</code>, enthält eine (Un-)Gleichung einen anderen Vergleichsoperator, nämlich ", "type": "text", "casesensitive": false, "unit": "." },
                { "html": "Nur Datensätze, die alle (Un-)Gleichungen erfüllen, stehen in der Ergebnistabelle" },
                { "html": "Nur Datensätze, die nur eine der (Un-)Gleichungen erfüllen, stehen in der Ergebnistabelle" },
                { "html": "Nur Datensätze, die mindestens eine der (Un-)Gleichungen erfüllen, stehen in der Ergebnistabelle", "correct": true },
                { "html": "Nur Datensätze, die keine der (Un-)Gleichungen erfüllen, stehen in der Ergebnistabelle" }
            ]
        }
    },
    {
        "task": "<p><code>OR</code> verknüpft also zwei Auswahlbedingungen so, dass mindestens eine der Auswahlbedingungen erfüllt sein müssen, damit der Datensatz für die Ergebnistabelle berücksichtigt wird.</p><p>Schreibe nun eine Abfrage, die die kompletten Datensätze zu den Verdächtigen liefert, die eine Brille haben oder graue Haare (oder beides).</p>",
        "code": "SELECT name, geschlecht, groesse, haare \n  FROM VERDAECHTIGE \n  WHERE geschlecht = 'm' \n    OR groesse >= 190",
        "readonly": false,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "between", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „BETWEEN“ nicht erlaubt…" },
            { "type": "keyword", "value": "in", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „IN“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 7, "fine": 1, "msg": "Alle Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "id", "fine": 1, "msg": "Das erste Attribut muss „id“ sein" },
            { "type": "attributeName", "index": 1, "value": "name", "fine": 1, "msg": "Das zweite Attribut muss „name“ sein" },
            { "type": "attributeName", "index": 2, "value": "geschlecht", "fine": 1, "msg": "Das dritte Attribut muss „geschlecht“ sein" },
            { "type": "attributeName", "index": 3, "value": "alter", "fine": 1, "msg": "Das vierte Attribut muss „alter“ sein" },
            { "type": "attributeName", "index": 4, "value": "groesse", "fine": 1, "msg": "Das zweite Attribut muss „groesse“ sein" },
            { "type": "attributeName", "index": 5, "value": "haare", "fine": 1, "msg": "Das dritte Attribut muss „haare“ sein" },
            { "type": "attributeName", "index": 6, "value": "brille", "fine": 1, "msg": "Das vierte Attribut muss „brille“ sein" },
            { "type": "sameResult", "value": "SELECT * FROM VERDAECHTIGE WHERE brille OR haare = 'grau'", "fine": 1 },
            { "type": "accept", "unlock": true }
        ]
    }
];

window.sqlCodingTask = {
    levels: LEVELS
};
})(window);
